#!/usr/bin/env bash
#set -x
############################################################################################### 
# Licensed Materials - Property of IBM
#
# 5724-T60 5608-A91
# (C) Copyright IBM Corp. 2008, 2009  All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication, or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
###############################################################################################
# Verify input
#TODO:need detailed usage statement

printusage() {
echo "usage: DB2Indexing.sh DB2_ADMIN DB2_PASS DB2INSTALLDIR DBNAME
  where
  DB2_ADMIN is the Database Instance Owner specified during the install
  DB2_PASS is the password of the database instance owner
  DB2INSTALLDIR is the DB2 install directory Example /opt/IBM/DB2SKLMV25 (In case of non root install, its instance home directory including sqllib Example /home/testuser/sqllib)   
  DBNAME is the database name, default is SKLMDB"
exit 1
}

   export DB2ADMIN="$1"
   export DB2PASS="$2"
   export INSTALLDIR="$3"
   export DBNAME="$4"


if [ "$DB2ADMIN" =  "" ]; then
   printusage
fi

if [ "$DB2PASS" =  "" ]; then
   printusage
fi
if
[ "$INSTALLDIR" = "" ]; then
   printusage
fi
if
[ "$DBNAME" = "" ]; then
   printusage
fi


if [ -d "${INSTALLDIR}" ]; then
#. ${INSTANCEHOME}/sqllib/db2profile
${INSTALLDIR}/bin/db2 "connect to $DBNAME user $DB2ADMIN using $DB2PASS" >>../DB2Indexing.log
${INSTALLDIR}/bin/db2 "CREATE INDEX GRP_NAME_IDX ON KMT_GROUP(GROUPNAME)" >> ../DB2Indexing.log
 

 
  RC=$?
else
  echo "Error:" $INSTALLDIR " does not exist"
  RC=-10
fi

if [ $RC -eq 0 ]; then
  echo "Indexing of DB2 instance is complete."
  RC=$?
fi
exit $rc
