import sys
import java
import re
import sre

def regexp(pattern, string, flags=0):
        if(re.compile(pattern, flags).search(string)==None): return 0
        else: return 1

def regexpn(pattern, string, flags=0):
        r = re.compile(pattern, flags).subn("", string)
        return r[1]

def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef
errorCode = ""
errorInfo = ""

#################### WAS CONFIG UTILS #########################
#
# All defined procedures return "SUCCESS" upon successful
# completion of the said operation. Other return codes
# could be defined and used by the caller/callee for
# whatever purpose
#
SUCCESS = "SUCCESS"
# No failure detected, but, config operation was not performed.
# Hence, configuration is UNCHANGED
UNCHANGED = "UNCHANGED"
# Failure
FAILURE = "FAILURE"

LINE_SEPARATOR = java.lang.System.getProperty('line.separator')
PATH_SEPARATOR = java.lang.System.getProperty('path.separator')

#################### Procedures #########################
######
# set_env_var_node {node varname varval descript}
# Sets the env variable 'varname' with value 'varval' under
# the scope of node

# The following puts is useful for debugging in case of syntax
# errors in specific procs
#puts "--> profiling proc set_env_var_node"
def set_env_var_node ( node, varname, varval, descript ):
        global AdminConfig

        print "--> proc set_env_var_node"

        entry = find_env_var_node(node, varname )
        print "--> return entry for "+varname+" is "+entry
        if (regexp("VariableSubstitutionEntry", entry) == 1):
                value = ["value", varval]
                dsc = ["description", descript]
                attr = [value, dsc]
                AdminConfig.modify(entry, attr )
                found = "true"
                print "--> found the variable, and update the value to "+varval+" *****"
                return "SUCCESS"
        elif (regexp("VariableMap", entry) == 1):
                sname = ["symbolicName", varname]
                dsc = ["description", descript]
                var = ["value", varval]
                attr = [sname, var, dsc]
                print "--> "+varname+" not found, creating and setting to "+varval+" *****"
                AdminConfig.create("VariableSubstitutionEntry", entry, attr )
                return "SUCCESS"
        #endIf 
        return "UNCHANGE"
#endDef 

######
# find_env_var_node {node varname}
# Find the env variable 'varname' under the scope of node

#puts "--> profiling proc find_env_var_node"
def find_env_var_node ( node, varname ):
        global AdminConfig

        print "--> proc find_env_var_node"
        nid = AdminConfig.getid("/Node:"+node )
        print "--> nid: "+nid
        vlist = AdminConfig.list("VariableSubstitutionEntry", nid ).split(LINE_SEPARATOR)

        # Need to set var at the node scope. Multiple variable maps can
        # show up at the node level, because of the underlying server-scope
        # variable maps.
        vmlist = AdminConfig.list("VariableMap", nid ).split(LINE_SEPARATOR)
        for vid in vmlist:
                print "--> vid = "+vid
                if (regexp("/servers/", vid) == 0):
                        if (regexp("/nodes/", vid) == 1):
                                # Found the variable map corresponding to the node
                                found = "false"
                                i = 0  #forStart
                                while ( ( i < len(vlist) )  ):  #forTest
                                        entry = vlist[i]
                                        if (regexp("/servers/", entry) == 0):
                                                if (regexp("/nodes/", entry) == 1):
                                                        symname = AdminConfig.showAttribute(entry, "symbolicName" )
                                                        print "--> symbolic name is "+symname
                                                        if (symname == varname):
                                                                found = "true"
                                                                print "--> found the variable, and the entry id is "+entry+" *****"
                                                                print "--> break from for loop "
                                                                break 
                                                        #endIf 
                                                #endIf 
                                        #endIf 
                                        i += 1  #forNext
                                #endWhile  (#endFor)
                                if (found == "false"):
                                        entry = vid
                                        print "--> the variable is not found, return vid "+vid+" "
                                #endIf 
                                return entry
                        #endIf 
                #endIf 
        #endFor 
        print "--> nothing located and will return empty entry !!!!!"
        return ""
#endDef 


######
# create_sklm_j2c_auth_alias {alias_id desc userid password}
#
#   This procedure creates the J2C authentication alias used by
#   sklm DataSource.  This alias will have the name as 
#   <node_name>/sklm_db.
#

#puts "--> profiling proc create_sklm_j2c_auth_alias"

def create_sklm_j2c_auth_alias ( alias_id, desc, userid, password ):
        global AdminConfig

        print "--> proc create_sklm_j2c_auth_alias"
        adid = find_sklm_j2c_auth_alias(alias_id )
        uid = ["userId", userid]
        pw = ["password", password]
        print "--> attempt to find J2C authentication alias; which is : "+adid
        print "--> passed in uid is : "+str(uid)

        if (adid == ""):
                securityId = AdminConfig.list("Security" )
                print "--> security id is - "+securityId

                al = ["alias", alias_id]
                dsc = ["description", desc]
                attr = [al, uid, pw, dsc]

                AdminConfig.create("JAASAuthData", securityId, attr )
                print "--> create sklm j2c authentication alias id:   "
        else:
                print "--> found J2C authentication alias, attempt to modify it."
                attr = [uid, pw]
                # puts "--> $attr "
                AdminConfig.modify(adid, attr )
        #endElse 
        return "SUCCESS"
#endDef 

######
# find_sklm_j2c_auth_alias {alias_id}
#
#   This procedure tries to find the J2C authentication alias with
#   the userId "sklm" and part of alias name as "sklm_db".  If
#   the alias is found, the alias id will be returned.  Otherwise, 
#   an empty string will be returned.
#

#puts "--> profiling proc find_sklm_j2c_auth_alias"

def find_sklm_j2c_auth_alias ( alias_id ):
        global AdminConfig

        print "--> proc find_sklm_j2c_auth_alias"
        print "--> find j2c authentication alias "+alias_id
        securityId = AdminConfig.list("Security" )
        print "--> security id is - "+securityId
        adEntry = AdminConfig.showAttribute(securityId, "authDataEntries")
        adEntry = wsadminToList(adEntry)
        print "--> auth data entry is - "+str(adEntry)
        nEntries = len(adEntry)
        print "--> nEntries: "+str(nEntries)
        adid = ""
        i = 0  #forStart
        while ( i < nEntries ):  #forTest
                adi = adEntry[i]
                print "--> adi "+adi
                #?PROBLEM? (jacl 2058) previous LINDEX may need variable.split("xx")
                #     set userid [$AdminConfig showAttribute $adi userId] 
                #     puts "--> current userId is $userid"  
                #     if { $userid == "sklm" } 
                alias = AdminConfig.showAttribute(adi, "alias" )
                print "--> the current alias "+alias
                #     if {[regexp $alias_id $alias] == 1} 
                if (alias_id == alias):
                        print "--> found j2c alias "+alias_id+" with alias id "+adi
                        # set sklmAlias $alias
                        adid = adi
                        break 
                #endIf 
                i += 1  #forNext
        #endWhile  (#endFor)
        print "--> sklm j2c authentication alias id:  "+adid+" "
        return adid
#endDef 

######
# find_object_id {scopeId obType obKey obValue}
#
# This procedure finds the object id based on the input parameters.
# They are:
# scopeId : the scope that the object is under, such as server id (sid)
# obType  : the type of object, such as DataSource, WASQueueConnectionFactory
# obKey   : the key word to be used for comparison, such as jndiName, implementationClassName
#   obValue : the value of the key word to be compared
#
# If the object is found, the object id will be returned.
# If the object if not found, an empty string will be returned.
#

#puts "--> profiling proc find_object_id"
def find_object_id ( scopeId, obType, obKey, obValue ):
        global AdminConfig

        print "--> proc find_object_id"
        print "--> search scope id         : "+scopeId
        print "--> search object type id   : "+obType
        print "--> search object key word  : "+obKey
        print "--> search object key value : "+obValue

        oblist = AdminConfig.list(obType, scopeId )
        oblist = wsadminToList(oblist)
        noblist = len(oblist)
        print "--> number of object list: "+str(noblist)
        obid = ""
        i = 0  #forStart
        while ( i < noblist ):  #forTest
                obi = oblist[i]
                curObValue = AdminConfig.showAttribute(obi, obKey )
                print "--> current value of the object key is "+curObValue

                if (curObValue == obValue):
                        obid = obi
                        break 
                #endIf 
                i += 1  #forNext
        #endWhile  (#endFor)

        print "--> object id is :  "+obid+" "
        return obid
#endDef 

#-----------------------------------------------------------------
# crt_jdbc_provider {scope dbtype is_xa is_was6}
#
# Create the jdbc driver provider under the scope which can be at cluster or server level
#    There are three database type - IBM_DB, ORACLE_DB, and MS_DB.  With IBM_DB, it can
#    be either type 2 or type 4.
#
#puts "--> profiling proc crt_jdbc_provider"

def crt_jdbc_provider ( scope, dbtype, is_xa, is_was6 ):
        global AdminConfig

        print "--> proc crt_jdbc_provider"

        sklm_jdbc = find_jdbc_driver(scope, dbtype, is_xa, "is_was6" )

        # The following section will be either created
        # of modified based on the discover of the proper jdbc provider

        if (is_xa == "true"):
                xa = ["xa", "true"]
                xa_txt = "XA"
        else:
                xa = ["xa", "false"]
                xa_txt = "non-XA"
        #endElse 

        if (dbtype == "IBM_DB"):
                if (is_was6 == "false"):
                        cp = ["classpath", "${SKLM_DB_JDBC_DRIVER_PATH}/db2java.zip"]
                        ipn = ["implementationClassName", "COM.ibm.db2.jdbc.DB2XADataSource"]
                        name = ["name", "SKLM DB2 JDBC Provider (XA)"]
                else:
                        cp = ["classpath", "${SKLM_DB_JDBC_DRIVER_PATH}/db2jcc.jar"+PATH_SEPARATOR+"${SKLM_DB_JDBC_DRIVER_PATH}/db2jcc_license_cisuz.jar"+PATH_SEPARATOR+"${SKLM_DB_JDBC_DRIVER_PATH}/db2jcc_license_cu.jar"]
                        name = ["name", "SKLM "+xa_txt+" DB2 JDBC Provider"]
                        if (is_xa == "true"):
                                ipn = ["implementationClassName", "com.ibm.db2.jcc.DB2XADataSource"]
                        else:
                                ipn = ["implementationClassName", "com.ibm.db2.jcc.DB2ConnectionPoolDataSource"]
                        #endElse 
                #endElse 
                dsp = ["description", "SKLM DB2 JDBC "+xa_txt+" Provider"]
        #endIf 
        if (dbtype == "ORACLE_DB"):
                cp = ["classpath", "${SKLM_DB_JDBC_DRIVER_PATH}/ojdbc14.jar"]
                ipn = ["implementationClassName", "oracle.jdbc.xa.client.OracleXADataSource"]
                dsp = ["description", "SKLM JDBC2 "+xa_txt+" Compliant Provider (ORACLE)"]
                if (is_was6 == "false"):
                        name = ["name", "SKLM ORACLE JDBC Provider (XA)"]
                else:
                        name = ["name", "SKLM "+xa_txt+" ORACLE JDBC Provider"]
                        if (is_xa == "false"):
                                ipn = ["implementationClassName", "oracle.jdbc.pool.OracleConnectionPoolDataSource"]
                        #endIf 
                #endElse 
        #endIf 
        if (dbtype == "MS_DB"):
                ipn = ["implementationClassName", "com.jnetdirect.jsql.JSQLXADataSource"]
                cp = ["classpath", "${SKLM_DB_JDBC_DRIVER_PATH}/JSQLConnect.jar"]
                dsp = ["description", "SKLM JDBC2 "+xa_txt+" Compliant Provider (MSSQL)"]
                if (is_was6 == "false"):
                        name = ["name", "SKLM MSSQL JDBC Provider (XA)"]
                else:
                        name = ["name", "SKLM "+xa_txt+" MSSQL JDBC Provider"]
                        if (is_xa == "false"):
                                ipn = ["implementationClassName", "com.jnetdirect.jsql.JSQLConnectionPoolDataSource"]
                        #endIf 
                #endElse 
        #endIf 

        attr = [name, cp, ipn, dsp, xa]
        print "--> attr list is "+str(attr)

        # If SKLM JDBC provider is not found, create a new jdbc provider
        if (sklm_jdbc == ""):
                print "--- "
                print "--- not found SKLM "+xa_txt+" JDBC provider"
                print "--- will create SKLM "+xa_txt+" JDBC provider"
                print "--- "

                sklm_jdbc = AdminConfig.create("JDBCProvider", scope, attr )
        else:
                print "--- "
                print "--- found SKLM "+xa_txt+" JDBC driver"
                # puts "--- JDBC driver will be modified accordingly" 
                print "--- "

                # $AdminConfig modify $sklm_jdbc {{classpath ""}}
                # $AdminConfig modify $sklm_jdbc $attr
        #endElse 
        return sklm_jdbc
#endDef 


#-----------------------------------------------------------------
# get_name - Return the base name of the config object. 
#-----------------------------------------------------------------
#puts "--> profiling proc get_name"
def get_name ( args ):
        # arg[0] - object id

        id = args.split(LINE_SEPARATOR)[0]
        endIndex = (id.find("(") - 1)

        return id[0:endIndex+1]
#endDef 


#-----------------------------------------------------------------
# find_jdbc_driver {scope dbtype is_xa is_was6}
# Find the JDBC driver resource under the scope

# The following puts is useful for debugging in case of syntax
# errors in specific procs
#puts "--> profiling proc find_jdbc_driver"

def find_jdbc_driver ( scope, dbtype, is_xa, is_was6 ):
        global AdminConfig

        print "--> proc find_jdbc_driver"

        jdbclist = AdminConfig.list("JDBCProvider", scope ).split(LINE_SEPARATOR)
        njdbc = len(jdbclist)
        found = "false"
        if (dbtype == "IBM_DB"):
                if (is_was6 == "false"):
                        classname = "COM.ibm.db2.jdbc.DB2XADataSource"
                        provider_name = "SKLM DB2 JDBC Provider"
                else:
                        if (is_xa == "true"):
                                provider_name = "SKLM XA DB2 JDBC Provider"
                                classname = "com.ibm.db2.jcc.DB2XADataSource"
                        else:
                                provider_name = "SKLM non-XA DB2 JDBC Provider"
                                classname = "com.ibm.db2.jcc.DB2ConnectionPoolDataSource"
                        #endElse 
                #endElse 
        #endIf 
        if (dbtype == "ORACLE_DB"):
                classname = "oracle.jdbc.xa.client.OracleXADataSource"
        #endIf 
        if (dbtype == "MS_DB"):
                classname = "com.jnetdirect.jsql.JSQLXADataSource"
        #endIf 

        scope_name = get_name(scope )
        print "--> the scope name of the scope is "+scope_name
        print "--> number of jdbc provider is "+str(njdbc)
        print "--> searching jdbc class "+classname

        # set sklm_jdbc [find_object_id 

        sklm_jdbc = ""
        i = 0  #forStart
        while ( i < njdbc ):  #forTest
                jdbcId = jdbclist[i]
                #?PROBLEM? (jacl 372) previous LINDEX may need variable.split("xx")
                print "--> current jdbcid is "+jdbcId
                if (regexp(provider_name, jdbcId) == 1):

                        endIndex = (jdbcId.find("|") - 1)
                        if (endIndex < 0):
                                endIndex = (jdbcId.find(":") - 1)
                        #endIf 
                        sString = jdbcId[0:endIndex+1]
                        stIndex = (sString.rfind("/") + 1)
                        sName = sString[stIndex:endIndex+1]

                        print "--> Extracted jdbc provider scope name is "+sName

                        if (scope_name == sName):
                                impclass = AdminConfig.showAttribute(jdbcId, "implementationClassName" )
                                print "--> extracted jdbc class name is "+impclass
                                if (impclass == classname):
                                        sklm_jdbc = jdbcId
                                        break 
                                #endIf 
                        #endIf 
                #endIf 
                i += 1  #forNext
        #endWhile  (#endFor)

        print "--> sklm_jdbc: "+sklm_jdbc
        return sklm_jdbc
#endDef 

######
# update_sklm_datasource {dburl dbuserid dbpasswd jdbcid drivertype dbtype dsname dsctext was6}

#puts "--> profiling proc update_sklm_datasource"

# proc update_sklm_datasource {dburl dbuserid dbpasswd jdbcid drivertype dbtype}
def update_sklm_datasource ( dburl, j2cAlias, dbuserid, dbpasswd, jdbcid, drivertype, dbtype, dsname, dsctext, was6 ):
        global AdminConfig

        print "--> proc update_sklm_datasource"
        print "--> sklm db url is "+dburl
        print "--> sklm db J2C alias name is "+j2cAlias
        print "--> sklm db userid is "+dbuserid
        # puts "--> database user password is $dbpasswd"
        print "--> sklm jdbcid is "+jdbcid
        print "--> sklm db type is "+dbtype
        print "--> sklm db jdbc driver type is "+str(drivertype)
        print "--> the data source jndi name is "+dsname
        print "--> the description of the data source is "+dsctext
        print "--> WAS 6 data source is "+was6

        # oracle url - jdbc:oracle:thin:sklm/password@myhost:1521:sklmdb
        # oracle url - jdbc:oracle:thin:@192.168.6.97:1521:sklmdb
        # ms sql url - jdbc:JSQLConnect://192.168.6.181:1433/database=sklmdb
        # db2 url    - jdbc:db2://hostname:50000/sklmdb 
	
	# Values used by WebSphere Connection Manager to pretest new connections
	PRE_TEST_SQL = "SELECT 1 FROM KMT_METADATA"
	RETRY_COUNT = "3"
	RETRY_INTERVAL = "3"
	
        elems = dburl.split(":" )
        num = len(elems)
        pos = (num - 1)
        dbname = elems[pos]
        port_number = 0
        if (dbtype == "IBM_DB"):
                if (drivertype == 4):
                        lastelem = dbname
                        lelems = lastelem.split("/")
                        dbname = lelems[1]
                        port_number = lelems[0]

                        pos = (num - 2)
                        mixipaddr = elems[(num-2)]
                        ipelems = mixipaddr.split("/")
                        ipaddr = ipelems[(len(ipelems) -1)]
                        print "--> IBM DB2 Server IP address is "+ipaddr
                #endIf 
        #endIf 
        elif (dbtype == "ORACLE_DB"):
                pos = (num - 2)
                port_number = elems[pos]
                #?PROBLEM? (jacl 2431) previous LINDEX may need variable.split("xx")
        elif (dbtype == "MS_DB"):
                lastelem = dbname
                lelems = lastelem.split("=" )
                lnum = len(lelems)
                dbname = lelems[(lnum - 1)]
                #?PROBLEM? (jacl 2436) previous LINDEX may need variable.split("xx")
                lelems = lastelem.split("/")
                port_number = lelems[0]
                #?PROBLEM? (jacl 2438) previous LINDEX may need variable.split("xx")

                pos = (num - 2)
                mixipaddr = elems[(num-2)]
                #?PROBLEM? (jacl 2441) previous LINDEX may need variable.split("xx")
                ipelems = mixipaddr.split("/")
                ipaddr = ipelems[(len(ipelems) -1)]
                #?PROBLEM? (jacl 2443) previous LINDEX may need variable.split("xx")
                print "--> MS SQL Server IP address is "+ipaddr
        #endIf 

        print "--> elements are "+str(elems)+" ; number elements is "+str(num)
        print "--> sklm db name is "+dbname
        print "--> modify port number with value - "+str(port_number)

        # Create sklm j2c authentication alias
        rc = create_sklm_j2c_auth_alias(j2cAlias, "SKLM database user j2c authentication alias", dbuserid, dbpasswd )

        # Update (or create) SKLM data source

        if (dbtype == "IBM_DB"):
                if (was6 == "true"):
                        dstemp = AdminConfig.listTemplates("DataSource", "DataSource_DB2_UNI_1" ).split(LINE_SEPARATOR)[0]
                        #?PROBLEM? (jacl 2459) previous LINDEX may need variable.split("xx")
                else:
                        dstemp = AdminConfig.listTemplates("DataSource", "DataSource_4" ).split(LINE_SEPARATOR)[0]
                        #?PROBLEM? (jacl 2461) previous LINDEX may need variable.split("xx")
                #endElse 
                print "--> DB2 DataSource template id is -- "+dstemp
        #endIf 
        if (dbtype == "ORACLE_DB"):
                dstemp = AdminConfig.listTemplates("DataSource", "DataSource_ora_6" )[0]
                #?PROBLEM? (jacl 2466) previous LINDEX may need variable.split("xx")
                print "--> Oracle DB DataSource template id is -- "+dstemp
        #endIf 
        if (dbtype == "MS_DB"):
                dstemp = AdminConfig.listTemplates("DataSource", "DataSource_MS_2" )
                print "--> MS SQL Server DataSource template id is -- "+dstemp
        #endIf 

        name = ["name", dsctext]
        jndiname = ["jndiName", dsname]
        dsc = ["description", dsctext]
        if (was6 == "true"):
                scsize = ["statementCacheSize", 50]
        else:
                scsize = ["statementCacheSize", 100]
        #endElse 
        authd = ["authDataAlias", j2cAlias]
        amap = [["mappingConfigAlias", ""], ["authDataAlias", j2cAlias]]
  #endIf
        mapp = ["mapping", amap]

        minPoolSize = 5
        maxPoolSize = 30

        # Find datasource for the node:server, if exists
        dsid = find_object_id(jdbcid, "DataSource", "jndiName", dsname )
        if (dsid == ""):
                print "--- "+dsctext+" does not exist and will be created"
                attr = [name, jndiname, dsc, scsize, authd, mapp]
                print "--> attr list is "+str(attr)
                dsid = AdminConfig.createUsingTemplate("DataSource", jdbcid, attr, dstemp )

                # get config id of the new datasource
                # set dsid [find_object_id $jdbcid "DataSource" "jndiName" $dsname]
                print "--> datasource id: "+str(dsid)
        else:
                print "--- dsctext exists and will be modifid"
                cPool = AdminConfig.showAttribute(dsid, "connectionPool" )
                minPoolSize = AdminConfig.showAttribute(cPool, "minConnections" )
                maxPoolSize = AdminConfig.showAttribute(cPool, "maxConnections" )

                sCacheSize = AdminConfig.showAttribute(dsid, "statementCacheSize" )
                scsize = ["statementCacheSize", sCacheSize]
                attr = [name, dsc, scsize, authd, mapp]
                # set attr       [list $name $jndiname $dsc $scsize $authd $mapp]
                print "--> attr list is "+str(attr)
                AdminConfig.modify(dsid, attr )
        #endElse 

        if (dsid != ""):
                rc = update_sklm_datasource_props(dsid, minPoolSize, maxPoolSize )
                if (rc != "SUCCESS"):
                        return rc
                #endIf 
                if (dbtype == "IBM_DB"):

                        if (drivertype == 4):
                                propSet = AdminConfig.create("J2EEResourcePropertySet", dsid, [] )
                                attrs = [["name", "databaseName"], ["type", "java.lang.String"], ["value", dbname]]
                                AdminConfig.create("J2EEResourceProperty", propSet, attrs )
                                attrs = [["name", "driverType"], ["type", "java.lang.Integer"], ["value", "4"]]
                                AdminConfig.create("J2EEResourceProperty", propSet, attrs )
                                attrs = [["name", "serverName"], ["type", "java.lang.String"], ["value", ipaddr]]
                                AdminConfig.create("J2EEResourceProperty", propSet, attrs )
                                attrs = [["name", "portNumber"], ["type", "java.lang.Integer"], ["value", port_number]]
                                AdminConfig.create("J2EEResourceProperty", propSet, attrs )
                                attrs = [["name", "preTestSQLString"], ["type", "java.lang.String"], ["value", PRE_TEST_SQL]]
                                AdminConfig.create("J2EEResourceProperty", propSet, attrs )
                                attrs = [["name", "validateNewConnection"], ["type", "java.lang.Boolean"], ["value", "true"]]
                                AdminConfig.create("J2EEResourceProperty", propSet, attrs )
                                attrs = [["name", "validateNewConnectionRetryCount"], ["type", "java.lang.String"], ["value", RETRY_COUNT]]
                                AdminConfig.create("J2EEResourceProperty", propSet, attrs )
                                attrs = [["name", "validateNewConnectionRetryInterval"], ["type", "java.lang.String"], ["value", RETRY_INTERVAL]]
                                AdminConfig.create("J2EEResourceProperty", propSet, attrs )
                        else:
                                rc = update_resource_property(dsid, "2", "propertySet", "resourceProperties", "databaseName", dbname )
                        #endElse 

                elif (dbtype == "ORACLE_DB"):

                        rc = update_resource_property(dsid, "2", "propertySet", "resourceProperties", "databaseName", dbname )
                        rc = update_resource_property(dsid, "2", "propertySet", "resourceProperties", "portNumber", port_number )
                        rc = update_resource_property(dsid, "2", "propertySet", "resourceProperties", "URL", dburl )

                elif (dbtype == "MS_DB"):

                        rc = update_resource_property(dsid, "2", "propertySet", "resourceProperties", "databaseName", dbname )
                        rc = update_resource_property(dsid, "2", "propertySet", "resourceProperties", "portNumber", port_number )
                        rc = update_resource_property(dsid, "2", "propertySet", "resourceProperties", "serverName", ipaddr )
                #endIf 
                return rc
        else:
                return "FAILURE"
        #endElse 
#endDef 


#####
# update_transaction_attribute {}

#puts "--> profiling proc update_transaction_attribute"
def update_transaction_attribute (sid, attrName, attrValue):
        global AdminConfig

        tranServiceId=AdminConfig.list("TransactionService", sid)
        attr=[attrName, attrValue]
        attrs = [attr]
        AdminConfig.modify(tranServiceId, attrs)

        return "SUCCESS"
#endDef 

######
# update_sklm_datasource_props {}

#puts "--> profiling proc update_sklm_datasource_props"
def update_sklm_datasource_props ( dsid, minPoolSize, maxPoolSize ):
        global AdminConfig

        print "--> proc update_sklm_datasource_props"
        print "--> dsid: "+dsid

        if (minPoolSize == ""):
                minPoolSize = 5
        #endIf 
        if (maxPoolSize == ""):
                maxPoolSize = 30
        #endIf 
        
	# Values used by WebSphere Connection Manager to pretest existing connections
        RETRY_INTERVAL="3"

        cid = AdminConfig.showAttribute(dsid, "connectionPool" )
        print "--> SKLM datasource id is "+dsid
        print "--> connection pool id is "+cid
        print "--> minimun pool size is "+str(minPoolSize)
        print "--> maximun pool size is "+str(maxPoolSize)

        aTimeout = AdminConfig.showAttribute(cid, "agedTimeout" )
        cTimeout = AdminConfig.showAttribute(cid, "connectionTimeout" )
        pPolicy = AdminConfig.showAttribute(cid, "purgePolicy" )
        rTime = AdminConfig.showAttribute(cid, "reapTime" )
        uTimeout = AdminConfig.showAttribute(cid, "unusedTimeout" )

        miPoolSize = ["minConnections", minPoolSize]
        maPoolSize = ["maxConnections", maxPoolSize]
        aTimeoutList = ["agedTimeout", aTimeout]
        cTimeoutList = ["connectionTimeout", cTimeout]
        uTimeoutList = ["unusedTimeout", uTimeout]
        rTimeList = ["reapTime", rTime]
        pPolicyList = ["purgePolicy", pPolicy]
        testConnection = ["testConnection", "true"]
        testConnectionInterval = ["testConnectionInterval", RETRY_INTERVAL]

        attrlist1 = [miPoolSize, maPoolSize, aTimeoutList, cTimeoutList, pPolicyList, rTimeList, uTimeoutList, testConnection, testConnectionInterval]
        conlist = ["connectionPool", attrlist1]
        attrlist2 = [conlist]
        AdminConfig.modify(dsid, attrlist2 )

        return "SUCCESS"
#endDef 


######
# create_scheduler {name jndiName description datasourceJNDIName datasourceAlias tablePrefix}
#
#   This procedure creates the J2C authentication alias used by
#   sklm DataSource.  This alias will have the name as 
#   <node_name>/sklm_db.
#

#puts "--> profiling proc create_scheduler"

def create_scheduler (scope, name, jndiName, description, datasourceJNDIName, datasourceAlias, tablePrefix, workManagerInfoJNDIName):
        global AdminConfig

        print "--> proc create_scheduler"
        nameAttr = ["name", name]
        jndiNameAttr = ["jndiName", jndiName]
        descriptionAttr = ["description", description]
        datasourceJNDINameAttr = ["datasourceJNDIName", datasourceJNDIName]
        datasourceAliasAttr = ["datasourceAlias", datasourceAlias]
        tablePrefixAttr = ["tablePrefix", tablePrefix]
        workManagerInfoJNDINameAttr = ["workManagerInfoJNDIName", workManagerInfoJNDIName] 
        print "--> attempt to find scheduler with name : "+name
	schedulerId = find_object_id(scope, "SchedulerConfiguration", "name", name);
        if (schedulerId == ""):
    	        schedulerProviderId = find_object_id(scope, "SchedulerProvider", "name", "SchedulerProvider")
                attr = [nameAttr, jndiNameAttr, descriptionAttr, datasourceJNDINameAttr, datasourceAliasAttr, tablePrefixAttr, workManagerInfoJNDINameAttr]
                AdminConfig.create("SchedulerConfiguration", schedulerProviderId, attr)
                print "--> created sklm scheduler"
        else:
                print "--> found existing scheduler, attempt to modify it."
                attr = [jndiNameAttr, descriptionAttr, datasourceJNDINameAttr, datasourceAliasAttr, tablePrefixAttr, workManagerInfoJNDINameAttr]
                # puts "--> $attr "
                AdminConfig.modify(schedulerId, attr)
        #endElse 
        return "SUCCESS"
#endDef 


def update_resource_property (parentId, propSetName, propName, prop):
        global AdminConfig
        print "--> proc update_resource_property"
        print tranServiceId
        propSet = AdminConfig.showAttribute(parentId, propSetName)
        print propSet
        pname1 = prop[0][1];
        print "Property name to update " + pname1
        found = "false"
        #TODO iterate to see if the property has been already set
        #Warning, if not done, it may result in the same property being added more than once. 
        if (found == "false"):
                print "--> Property "+pname1+" not found; will create the property"
                AdminConfig.create(propName, parentId, prop )
        #endIf 
        return "SUCCESS"


#endDef 



###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
#
# SCRIPT STARTS HERE
#
# Sets up SKLM for WAS-based deployment
#
###########################################################################################################
if (len(sys.argv) < 7):
        print "  "
        print "Incorrect number of args.  "
        print "   arg1 - node-name (eg: TIPNode)"
        print "   arg2 - server-name (eg: server1)"
        print "   arg3 - sklm home-path (eg: \"C:/Program Files/IBM/sklm\") (currently not used, but  might be useful in future"
        print "   arg4 - jdbc-path (eg: C:/PROGRA~1/IBM/SQLLIB/java/)"
        print "   arg5 - sklm_db_user (eg: sklmdb)"
        print "   arg6 - sklm-pwd (eg: secret)"
        print "   arg7 - db2 url (eg: jdbc:db2://<machine name>:<port>/<database name>)"
        exit
#endIf 

node = sys.argv[0]
server = sys.argv[1]
sklm_home = sys.argv[2]
jdbc_path = sys.argv[3]
sklm_db_user = sys.argv[4]
sklm_db_pwd = sys.argv[5]
db2_url = sys.argv[6]
jndiDSName = "jdbc/sklmDS"
sklmDSDescr = "SKLM DataSource"
sklmdbAlias = "sklm_db"
dbType = "IBM_DB"
#print "program file is "+sys.argv[0]
print "node name is "+node
print "server name is "+server
print "sklm home path is "+sklm_home
print "jdbc path is "+jdbc_path
print "sklm user is "+sklm_db_user
#print "sklm password is "+sklm_db_pwd
print "db2 url is "+db2_url
print "default jndiDSName is "+jndiDSName
print "default sklmDSDescr is "+sklmDSDescr
print "default dbType is "+dbType

sid = AdminConfig.getid("/Node:"+node+"/Server:"+server)

#SET SKLM_HOME at NODE level
rc = set_env_var_node(node, "SKLM_HOME", sklm_home, "SKLM 1.0 home directory" )
print "Debug --> return from setting SKLM_HOME. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf

#SET SKLM_DB_JDBC_DRIVER_PATH at NODE level
rc = set_env_var_node(node, "SKLM_DB_JDBC_DRIVER_PATH", jdbc_path, "Absolute path of IBM DB2 JDBC driver" )
print "Debug --> return from setting SKLM_DB_JDBC_DRIVER_PATH. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf

#CREATE J2C AUTHENTICATION ALIASES sklm_db
rc = create_sklm_j2c_auth_alias(sklmdbAlias, "SKLM database user J2C authentication alias", sklm_db_user, sklm_db_pwd )
print "Debug --> return from create_sklm_j2c_auth_alias sklm_db. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf

#CREATE non-XA DB2 JDBC Provider and DataSource 
jdbc_id = crt_jdbc_provider(sid, dbType, "false", "true" )
print "Debug --> return from crt_jdbc_provider. rc: "+rc
if (jdbc_id != ""):
        AdminConfig.save( )
#endIf

#UPDATE non-XA DataSource
rc = update_sklm_datasource(db2_url, "sklm_db", sklm_db_user, sklm_db_pwd, jdbc_id, 4, dbType, jndiDSName, sklmDSDescr, "true" )
print "Debug --> return from update_sklm_datasource Non-XA. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf 

#CREATE XA DB2 JDBC Provider and DataSource for SKLM scheduler
jdbc_id = crt_jdbc_provider(sid, dbType, "true", "true" )
print "Debug --> return from crt_jdbc_provider. rc: "+rc
if (jdbc_id != ""):
        AdminConfig.save( )
#endIf

#UPDATE XA DataSource
rc = update_sklm_datasource(db2_url, "sklm_db", sklm_db_user, sklm_db_pwd, jdbc_id, 4, dbType, "jdbc/sklmXADS", "SKLM scheduler XA Datasource", "true" )
print "Debug --> return from update_sklm_datasource Non-XA. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf 

#UPDATE Total Transaction attributes
rc = update_transaction_attribute (sid, "totalTranLifetimeTimeout", 600)
if (rc == "SUCCESS"):
        AdminConfig.save( )

#UPDATE propogatedOrBMTTranLifetimeTimeout
rc = update_transaction_attribute (sid, "propogatedOrBMTTranLifetimeTimeout", 600)
if (rc == "SUCCESS"):
        AdminConfig.save( )

tranServiceId=AdminConfig.list("TransactionService", sid)
prop = [["name", "ACCEPT_HEURISTIC_HAZARD"], ["value", "TRUE"], ["description", "Server-wide LPS (Last Participant Support)"], ["required", "false"]]
rc = update_resource_property(tranServiceId, "properties", "Property", prop)
print "Debug --> return from update_resource_property, rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf

#CREATE Scheduler Instance
rc = create_scheduler(sid, "SKLM Scheduler", "sched/sklmScheduler", "Scheduler used in SKLM application", "jdbc/sklmXADS", sklmdbAlias, "KMT_SCH_", "wm/default")
print "Debug --> return from create_scheduler. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf 



