#/bin/sh
# dbconf.sh
# Sample script to create TKLM WAS database configuration objects
# (TKLM_HOME env var, JDBC driver path, J2C authentication aliases,
# JDBC Provider & DataSource)

# WAS_HOME=C:\Program Files\IBM\tivoli\tip

# Args for dbconf.py script:
#   arg1 - node-name (eg: TIPNode)
#   arg2 - server-name (eg: server1)
#   arg3 - tklm home-path (eg: \"C:/Program Files/IBM/tklm\") (currently not used, but  might be useful in future)
#   arg4 - jdbc-path (eg: C:/PROGRA~1/IBM/SQLLIB/java/)
#   arg5 - tklm_db_user (eg: tklmdb)
#   arg6 - tklm-pwd (eg: secret)
#   arg7 - db2 url (eg: jdbc:db2://<machine name>:<port>/<database name>)
#
# Commented out values suitable for the RAD bundled WAS, with no security
#WASADMIN_CREDENTIALS=
WASADMIN_CREDENTIALS="-user iscadmin -password iscpass"
#PROFILE=AppSrv01
PROFILE=TIPProfile
#NODE=localhostNode01
NODE=TIPNode
SERVER=server1
TIP_HOME=/opt/IBM/tivoli/tip
TKLM_HOME=$TIP_HOME/products/tklm
JDBC_PATH=/opt/ibm/db2/V9.1/java/
DB_USER=tklmdb
DB_PASSWD=secret1a
DB_URL=jdbc:db2://127.0.0.1:50000/tklmdb

WSADMINCMD=$WAS_HOME/bin/wsadmin.sh

$WSADMINCMD $WASADMIN_CREDENTIALS -lang jython -profileName $PROFILE -f dbconf.py $NODE $SERVER $TKLM_HOME $JDBC_PATH $DB_USER $DB_PASSWD $DB_URL
