#/bin/sh
# dbconf.sh
# Sample script to create TKLM WAS database configuration
# (TKLM_HOME env var, JDBC driver path, J2C authentication aliases,
# JDBC Provider & DataSource)


# Args for dbconf.py script:
#	arg1 - node-name (eg: aserachiNode01)
#   arg2 - server-name (eg: server1)
#   arg3 - tklm home-path (eg: \"C:/Program Files/IBM/tklm\") (currently not used, but  might be useful in future)
#   arg4 - jdbc-path (eg: C:/PROGRA~1/IBM/SQLLIB/java/)
#   arg5 - tklm_db_user (eg: tklmdb)
#   arg6 - tklm-pwd (eg: secret)
#   arg7 - db2 url (eg: jdbc:db2://<machine name>:<port>/<database name>)
#
# Commented out values suitable for the RAD bundled WAS, with no security
#CREDENTIALS=
WAS_HOME=$1
PROFILE=$4
#NODE=localhostNode01
NODE=$5
SERVER=server1
TKLM_HOME=$WAS_HOME/products/tklm
JDBC_PATH=$6
DB_USER=$7
DB_PASSWD=$8
DB_URL=jdbc:db2://127.0.0.1:$9/tklmdb

WSADMINCMD=$WAS_HOME/bin/wsadmin.sh

$WSADMINCMD -user $2 -password $3 -lang jython -profileName $PROFILE -f dbconf.py $NODE $SERVER $TKLM_HOME $JDBC_PATH $DB_USER $DB_PASSWD $DB_URL
