##to invoke the script, you have to pass three arguements: <pathV1 or V2> <path v3 to ISKLM directory> <log with path>
import string
import sys
import shutil
from java.util import Calendar, Date
from java.io import File, BufferedReader, FileReader, IOException


#Need to see what roles are in V2 for later creation
def FindRoles ():
	writeLog("In FindRoles")        
	pathfiletoMigF = pathv1v2 + "/profiles/TIPProfile/config/cells/TIPCell/admin-authz.xml"
	try:
		f = File( pathfiletoMigF )
		bufStream = BufferedReader( FileReader( f ))
		while 1:
			line = bufStream.readLine()
			if(line is None): break
			if(line.find("<roles xmi:id=") != -1):
				outputFile.write(line);
				outputFile.write("\n");
		#endWhile
		outputFile.write("*************END ROLES********************");
		outputFile.write("\n");
		writeLog("Done with FindRoles")
		return 0
	except:
		writeLog("Error in FindRoles")
		return 101

def FindUserAssocRoles():
	writeLog("In FindUserAssocRoles") 
	try:
		result = AdminTask.listUserIDsOfAuthorizationGroup()
		writeLog("result: " + result)        
		outputFile.write(result);
		outputFile.write("\n");
		outputFile.write("*************END USERROLESASOC********************");
		outputFile.write("\n");
		writeLog("Done with FindUserAssocRoles")
		return 0
	except:
		writeLog("Error with FindUserAssocRoles")
		return 101

def FindGroupsAndAssocRoles():
	writeLog("In FindGroupsAndAssocRoles") 
	try:
		result = AdminTask.searchGroups('[-cn *]')
		writeLog("result: " + result)        
		outputFile.write(result);
		outputFile.write("\n");
		outputFile.write("*************END GROUPS********************");
		outputFile.write("\n");
		result = AdminTask.listGroupIDsOfAuthorizationGroup()
		writeLog("result: " + result)        
		outputFile.write(result);
		outputFile.write("\n");
		outputFile.write("*************END GROUP ROLES********************");
		outputFile.write("\n");
		writeLog("Done with FindGroupsAndAssocRoles")
		return 0
	except:
		writeLog("Error with FindGroupsAndAssocRoles")
		return 101
   
def FindGroupsAndUserAssociations():
	writeLog("In FindGroupsAndUserAssociations") 
	try:
		result = AdminTask.searchGroups('[-cn *]')
		writeLog("result: " + result)   
		#Loop through the groups and get members of the group
		tmpList = result.split('\n')
		x = 0
		while x < len(tmpList):
			groupName = tmpList[x].strip()
			result = AdminTask.getMembersOfGroup('[-uniqueName '+ groupName + ']')
			writeLog("result for group " + groupName + " = " + result)        
			outputFile.write(groupName);
			outputFile.write("\n");
			outputFile.write(result);
			outputFile.write("\n");
			x = x + 1
		outputFile.write("*************END GROUPSUSERASSOC********************");
		outputFile.write("\n");
		writeLog("Done with FindGroupsAndUserAssociations")
		return 0
	except:
		writeLog("Error with FindGroupsAndUserAssociations")
		return 101
   

def writeLog(record):
	file = open(logpath, "a+b")
	file.write(record);
	file.write("\n");
	file.close()

#  Main code is here.  

pathv1v2 = ""
pathv3 = ""
logpath = ""
rc = 0

if len(sys.argv) < 3 or len(sys.argv) > 3:
	sys.stderr.write("Invalid number of arguments\n")
	sys.exit(101)
else:
  if len(sys.argv) == 3:   	
	pathv1v2 = sys.argv[0]
	pathv3 = sys.argv[1]  
	logpath = sys.argv[2]  

	cal = Calendar.getInstance()
	date = cal.getTime()
	writeLog("Starting migrateAddRolesandUsers2Roles.py: " + date.toString())

	writeLog("pathv1v2=" + pathv1v2)
	writeLog("pathv3=" + pathv3)

	pathfiletoMigFile = pathv3 + "/migration/migrateAddRolesandUsers2Roles.input"
	outputFile = open(pathfiletoMigFile, "w")

	writeLog("FindRoles()")
	rc = FindRoles()

	if rc == 0:
		writeLog("FindGroupsAndAssocRoles()")
		rc = FindGroupsAndAssocRoles()

	if rc == 0:
		writeLog("FindUserAssocRoles()")
		rc = FindUserAssocRoles()

	if rc == 0:
		writeLog("FindGroupsAndUserAssociations()")
		rc = FindGroupsAndUserAssociations()

	outputFile.close()

	writeLog("Error code = " + str(rc))
	cal = Calendar.getInstance()
	date = cal.getTime()
	writeLog("Ending migrateAddRolesandUsers2Roles.py: " + date.toString())
	writeLog("\n")
