##to invoke the script, you have to pass three arguements: <pathV3 WAS> <path v3 to ISKLM directory> <log with path>
import string
import sys
import os
import shutil
from java.util import Calendar, Date
from java.io import File, BufferedReader, FileReader, IOException


#Parse the data file from V2
def LoadFileData ():
	writeLog("In LoadFileData")        
	pathfiletoMigData = pathv3 + "/migration/migrateAddRolesandUsers2Roles.input"
	try:
		f = File( pathfiletoMigData )
		bufStream = BufferedReader( FileReader( f ))
		#Read role information
		line = bufStream.readLine()
		if( line is None):
			writeLog( "Input File is Emptry Exiting" )
			return 101
		writeLog( "************* ROLES ********************" )
		while (line.find("*************END ROLES********************") == -1):
			if(line is None): break
			i = line.find("roleName=")
			x = line.rfind("/>")
			writeLog( line[i+10:x-1] )
			test = line[i+10:x-1]
			#do not add this to the list if klmApplicationRole(v1) or a TCR role
			if ((line[i+10:i+13] != "tcr") and (test != "klmApplicationRole")):
				roles.append(line[i+10:x-1]) 
			line = bufStream.readLine()
		#endWhile
		writeLog(str(roles))
    
		#Read group information
		line = bufStream.readLine()
		if( line is None):
			writeLog( "Input File does not contain GROUPS" )
			return 101
		writeLog( "******** GROUPS *********")
		while (line.find("*************END GROUPS********************") == -1):
			if(line is None): break
			i = line.find(",")
			# only add this if not empty and not klmgroup (v1)
			if ((line[3:i] != '') and (line[3:i] != "klmgroup")):
				writeLog( line[3:i] )
				groups.append(line[3:i]) 
			line = bufStream.readLine()
		#endWhile
		writeLog(str(groups))
    
		#clean up the groups that are in ISKLM by default
		removeDefMembersFromGroups()
    
		line = bufStream.readLine()
		if( line is None):
			writeLog( "Input File does not contain GROUP ROLES" )
			return 101
		while (line.find("ROLES********************") == -1):
			writeLog( "******** GROUP ROLES *********" )
			if(line is None): break
			tmpLine = line.replace("{"," ")
			tmpLine = tmpLine.replace("}"," ")
			tmpLine = tmpLine.strip()
			tmpList = tmpLine.split(',')
			x = 0
			while x < len(tmpList):
				linet = tmpList[x].strip()
				#remove the TCR roles since these will not get added to V 2.5
				if linet[0:3] == "tcr":
					x = x + 1
					continue
				pos = linet.find("=[]")
				# Remove roles that have nothing to assign
				if pos != -1:
					writeLog(linet[0:pos])
					x = x + 1
					continue
				else:
					#There are groups assigned rolls. Put the groups into a list
					pos = linet.find("=[")
					role = linet[0:pos]
					if (role == "klmApplicationRole"):
						role = "klmSecurityOfficer"
					#loop through and add groups to a list
					lin = linet
					grpL = []
					endPos = len(lin)
					if (lin.rfind("]") != -1):
					   grpL.append(lin[pos+2:endPos-1])
					else:
					   grpL.append(lin[pos+2:endPos])
					while lin.rfind("]") == -1:
						x = x + 1
						lin = tmpList[x].strip()
						endPos = len(lin)
						# look for end of list '],' else ',' 
						if (lin.rfind("]") != -1):
							tmp = lin[0:endPos-1]
							if (tmp == "klmgroup"):
								tmp = "klmSecurityOfficerGroup"
							grpL.append(tmp)
						else:
							tmp = lin[0:endPos]
							if (tmp == "klmgroup"):
								tmp = "klmSecurityOfficerGroup"
							grpL.append(tmp)
					#endWhile
					grpsinRoles.append([role,grpL])
				x = x + 1
			#endwhile
			line = bufStream.readLine()
		#endWhile
		writeLog(str(grpsinRoles))
    
		#Read user and role associations
		line = bufStream.readLine()
		if( line is None):
			writeLog( "Input File does not contain USER ROLES ASOC" )
			return 101
		while (line.find("USERROLESASOC********************") == -1):
			writeLog( "******** USERROLESASOC *********" )
			if(line is None): break
			tmpLine = line.replace("{"," ")
			tmpLine = tmpLine.replace("}"," ")
			tmpLine = tmpLine.strip()
			tmpList = tmpLine.split(',')
			x = 0
			while x < len(tmpList):
				linet = tmpList[x].strip()
				#remove the TCR roles since these will not get added to V 2.5
				if linet[0:3] == "tcr":
					x = x + 1
					continue
				pos = linet.find("=[]")
				# Remove roles that have nothing to assign
				if pos != -1:
					writeLog(linet[0:pos])
					x = x + 1
					continue
				else:
					#There are users assigned rolls. Put the users into a list
					pos = linet.find("=[")
					role = linet[0:pos]   
					if (role == "klmApplicationRole"):
						role = "klmSecurityOfficer"
					#loop through and add groups to a list
					lin = linet
					usrL = []
					endPos = len(lin)
					if (lin.rfind("]") != -1):
						usrL.append(lin[pos+2:endPos-1])
					else:
						usrL.append(lin[pos+2:endPos])
					while lin.rfind("]") == -1:
						x = x + 1
						lin = tmpList[x].strip()
						writeLog( lin )
						endPos = len(lin)
						# look for end of list '],' else ',' 
						if (lin.rfind("]") != -1):
							usrL.append(lin[0:endPos-1])
						else:
							usrL.append(lin[0:endPos])
					#endWhile
					usrinGrpRoles.append([role,usrL])
				x = x + 1
			#endwhile
			line = bufStream.readLine()
		#endWhile
		writeLog( "Users in Group Roles = " + str(usrinGrpRoles) )
    
		#Read user and group associations
		writeLog( "******** GROUPSUSERASSOC *********" )
		line = bufStream.readLine()
		if (line is not None): 
			while (line.find("END GROUPSUSERASSOC********") == -1):
				if(line is None): break
				group = line
				if (group[0:11] == "cn=klmgroup"):
					group = "cn=klmSecurityOfficerGroup,o=defaultWIMFileBasedRealm"
				line = bufStream.readLine()
				tmpList = []
				if (line is not None):
					while ( (line[0:3] != "cn=") and (line.find("END GROUPSUSERASSOC********") == -1)):
						linet = line.strip()
						pos = linet.find(", ")
						data = linet[pos+2:]
						if (data[0:11] == "cn=klmgroup"):
							data = "cn=klmSecurityOfficerGroup,o=defaultWIMFileBasedRealm"
						tmpList.append(data)
						line = bufStream.readLine()
					#endwhile
				usrinGrps.append([group,tmpList])
			#endWhile
		writeLog( "Users in Group = " + str(usrinGrps) )
		writeLog("Done in LoadFileData")
		return 0
	except:
		writeLog("Error in LoadFileData")
		return 101
   
#Parse the data file from V2
def AddRoles ():
	writeLog("In AddRoles")        
	#Read the V2.5 admin-authz.xml file and determine what roles already there.
	pathfiletoV25Authz = pathv3WAS + "/profiles/KLMProfile/config/cells/SKLMCell/admin-authz.xml"
	pathfiletoV25AuthzBkup = pathv3WAS + "/profiles/KLMProfile/config/cells/SKLMCell/admin-authz.xml.bkup"

	try:
		f = File( pathfiletoV25AuthzBkup )
		bufStream = BufferedReader( FileReader( f ))
		outputFile = open(pathfiletoV25Authz, "w")	
		rolesV3 = []
		maxnid = 0
		while 1:
			line = bufStream.readLine()
			if(line is None): 
				outputFile.close()
				writeLog( "line is None" )
				break
			if(line.find("<roles xmi:id=") != -1):
				i = line.find("roleName=")
				x = line.rfind("/>")
				y = line.find("SecurityRoleExt_")
				num = int(line[y+16:i-2])
				# detemine the max ID for roles for later
				if num > maxnid:
					maxnid = num
				rolesV3.append(line[i+10:x-1])
			outputFile.write(line)
			outputFile.write("\n")
		#endwhile
		writeLog( "Roles already in V2.5 " + str(rolesV3) )
		writeLog( "maxid = " + str(maxnid) )
		#Loop and remove roles from the V2 list if the role is already in V2.5
		for t in roles[:]:
			try:
				i = rolesV3.index(t)
			except ValueError:
				i = -1 # no match
			if i >= 0:
				try:
					roles.remove(t)
				except:
					continue
		#endfor
		writeLog( "Roles to add = " + str(roles) )
		#Add Roles in now
		outputFile = open(pathfiletoV25Authz, "w")
		f = File( pathfiletoV25AuthzBkup )
		bufStream = BufferedReader( FileReader( f ))
		addR = 0;
		addR2 = 0;
		while 1:
			line = bufStream.readLine()
			if(line is None): 
				outputFile.close()
				break
			#Just do this on the first one we find.
			if(line.find("<authorizations xmi:id=") != -1) and (addR == 0):
				if(line.rfind("/>") != -1):
					#add in all the roles "authorizations" not already in here
					addR = 1
					x = maxnid
					for t in roles[:]:
						x = x + 1
						newline = '  <authorizations xmi:id="RoleAssignmentExt_' + str(x) + '" role="SecurityRoleExt_' + str(x) + '"/>'
						writeLog( newline )
						outputFile.write(newline)
						outputFile.write("\n")
					#endfor
			if(line.find("<roles xmi:id=") != -1) and (addR2 == 0):
				if(line.rfind("/>") != -1):
					#add in all the roles "authorizations" not already in here
					addR2 = 1
					x = maxnid
					for t in roles[:]:
						x = x + 1
						newline = '  <roles xmi:id="SecurityRoleExt_' + str(x) + '" roleName="' + t + '"/>'
						writeLog( newline )
						outputFile.write(newline)
						outputFile.write("\n")
					#endfor
			outputFile.write(line)
			outputFile.write("\n")
		#endwhile
		writeLog("Done in AddRoles")
		return 0
	except:
		writeLog("Error in AddRoles")
		return 101
            
#Add the group
def AddGroups ():
	writeLog("In AddGroups")        
	writeLog( "add Groups &&&&&&&&&&&&" )
	try:
		for t in groups[:]:
			try:
				result = AdminTask.createGroup('[-cn '+ t +']')
				writeLog( result )
			except:
				writeLog("Cannot create " + t + " group")
		#endfor
		result = AdminTask.searchGroups('[-cn *]')
		writeLog( result )
		writeLog("Done in AddGroups")
		return 0
	except:
		writeLog("Error in AddGroups")
		return 101

#Add the roles to the groups
def AddRoles2Groups ():
	writeLog("In AddRoles2Groups")        
	writeLog( "Add Roles Groups &&&&&&&&&&&&" )
	try:
		for t in grpsinRoles[:]:
			for x in t[1]:
				try:
					params= "[-roleName "+ t[0] + " -groupids " + x + "]"
					writeLog(params)
					result = AdminTask.mapGroupsToAdminRole(params)
					writeLog(result)
				except:
					writeLog( "Cannot add "+t[0] + " to group " + x )
			#endfor
		#endfor
		writeLog("Done in AddRoles2Groups")
		return 0
	except:
		writeLog("Error in AddRoles2Groups")
		return 101

#Add the users to the roles
def AddUsers2RolesGroups ():
	writeLog("In AddUsers2RolesGroups")        
	writeLog( "Add Roles Groups to Users &&&&&&&&&&&&" )
	try:
		for t in usrinGrpRoles[:]:
			for x in t[1]:
				try:
					params= "[-roleName "+ t[0] + " -userids " + x + "]"
					writeLog(params)
					result = AdminTask.mapUsersToAdminRole(params)
					writeLog(result)
				except:
					writeLog("Cannot add " + t[0] + " to user " + x)
			#endfor
		#endfor
		writeLog("Done in AddUsers2RolesGroups")
		return 0
	except:
		writeLog("Error in AddUsers2RolesGroups")
		return 101

#Add the users to the groups
def AddUsers2Groups ():
	writeLog("In AddUsers2Groups")        
	writeLog( "Add Groups to Users &&&&&&&&&&&&" )
	try:
		for t in usrinGrps[:]:
			for x in t[1]:
				if x == "": continue
				try:
					params= "[-memberUniqueName  "+ x + " -groupUniqueName  " + t[0] + "]"
					writeLog(params)
					res = AdminTask.addMemberToGroup(params)
					writeLog(res)
				except:
					writeLog("Cannot add " + x + " to group " + t[0])
			#endfor
		#endfor
		writeLog("Done in AddUsers2Groups")
		return 0
	except:
		writeLog("Error in AddUsers2Groups")
		return 101

   
#remove the default members of groups from V2.5, because they may not match what was in V2
def removeDefMembersFromGroups ():
	writeLog( "removeDefMembersFromGroups &&&&&&&&&&&&" )
	result = AdminTask.getMembersOfGroup('[-uniqueName cn=klmSecurityOfficerGroup,o=defaultWIMFileBasedRealm]')
	if result == "": return
	pos = result.find(", ")
	uid = result[pos+2:]
	try:
		params= "[-memberUniqueName  "+ uid + " -groupUniqueName cn=klmSecurityOfficerGroup,o=defaultWIMFileBasedRealm]"
		writeLog(params)
		result = AdminTask.removeMemberFromGroup(params)
		writeLog(result)
	except:
		writeLog("Cannot remove " +uid + " from klmSecurityOfficerGroup")

def writeLog(record):
	file = open(logpath, "a+b")
	file.write(record);
	file.write("\n");
	file.close()

#  Main code is here.  

pathv3WAS = ""
pathv3 = ""
roles = []
groups = []
grpsinRoles = []
usrinGrpRoles = []
usrinGrps = []
logpath = ""
rc = 0

if len(sys.argv) < 3 or len(sys.argv) > 3:
	sys.stderr.write("Invalid number of arguments\n")
	sys.exit(101)
else:
  if len(sys.argv) == 3:    
	pathv3WAS = sys.argv[0]
	pathv3 = sys.argv[1]  
	logpath = sys.argv[2]  

	cal = Calendar.getInstance()
	date = cal.getTime()
	writeLog("Starting migrateAddRolesandUsers2V25.py: " + date.toString())

	writeLog("pathv3WAS=" + pathv3WAS)
	writeLog("pathv3=" + pathv3)
	writeLog("logpath=" + logpath)

	#check to see if the backup already exists
	V25AuthzBkup = pathv3WAS + "/profiles/KLMProfile/config/cells/SKLMCell/admin-authz.xml.bkup"
	f = File( V25AuthzBkup )
	if f.exists() == 0:
		pathfiletoMigF = pathv3WAS + "/profiles/KLMProfile/config/cells/SKLMCell/admin-authz.xml"
		shutil.copy2(pathfiletoMigF, V25AuthzBkup)
		writeLog("admin-authz.xml backed up.")

	writeLog("LoadFileData()") 
	rc = LoadFileData()
	
	if rc == 0:
		writeLog("AddRoles()") 
		rc = AddRoles()
	
	if rc == 0:
		writeLog("AddGroups()") 
		AddGroups()
	
	if rc == 0:
		writeLog("AddRoles2Groups()") 
		AddRoles2Groups()
    
	if rc == 0:
		writeLog("AddUsers2RolesGroups()") 
		AddUsers2RolesGroups()
    
	if rc == 0:
		writeLog("AddUsers2Groups()") 
		AddUsers2Groups()

	if rc == 0:
		result = AdminConfig.save()
		writeLog(str(result)) 

	writeLog("Error code = " + str(rc))
	cal = Calendar.getInstance()
	date = cal.getTime()
	writeLog("Ending migrateAddRolesandUsers2V25.py: " + date.toString())
	writeLog("\n")

