import sys
import java
import re
import sre

def regexp(pattern, string, flags=0):
        if(re.compile(pattern, flags).search(string)==None): return 0
        else: return 1

def regexpn(pattern, string, flags=0):
        r = re.compile(pattern, flags).subn("", string)
        return r[1]

def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef
errorCode = ""
errorInfo = ""

#################### WAS TKLM UNINSTALL UTILS #########################
#
# All defined procedures return "SUCCESS" upon successful
# completion of the said operation. Other return codes
# could be defined and used by the caller/callee for
# whatever purpose
#
SUCCESS = "SUCCESS"
# No failure detected, but, config operation was not performed.
# Hence, configuration is UNCHANGED
UNCHANGED = "UNCHANGED"
# Failure
FAILURE = "FAILURE"

LINE_SEPARATOR = java.lang.System.getProperty('line.separator')
PATH_SEPARATOR = java.lang.System.getProperty('path.separator')

#################### Procedures #########################
######
# delete_env_var_node {node varname}
# Deletes the env variable 'varname' under
# the scope of node
#puts "--> profiling proc delete_env_var_node"
def delete_env_var_node ( node, varname):
        global AdminConfig

        print "--> proc set_env_var_node"

        entry = find_env_var_node(node, varname )
        print "--> return entry for "+varname+" is "+entry
        if (regexp("VariableSubstitutionEntry", entry) == 1):
                print "--> found the variable, delete it"
                AdminConfig.remove(entry)
                return "SUCCESS"
        #endIf 
        return "UNCHANGE"
#endDef 

######
# find_env_var_node {node varname}
# Find the env variable 'varname' under the scope of node

#puts "--> profiling proc find_env_var_node"
def find_env_var_node ( node, varname ):
        global AdminConfig

        print "--> proc find_env_var_node"
        nid = AdminConfig.getid("/Node:"+node )
        print "--> nid: "+nid
        vlist = AdminConfig.list("VariableSubstitutionEntry", nid ).split(LINE_SEPARATOR)

        # Need to set var at the node scope. Multiple variable maps can
        # show up at the node level, because of the underlying server-scope
        # variable maps.
        vmlist = AdminConfig.list("VariableMap", nid ).split(LINE_SEPARATOR)
        for vid in vmlist:
                print "--> vid = "+vid
                if (regexp("/servers/", vid) == 0):
                        if (regexp("/nodes/", vid) == 1):
                                # Found the variable map corresponding to the node
                                found = "false"
                                i = 0  #forStart
                                while ( ( i < len(vlist) )  ):  #forTest
                                        entry = vlist[i]
                                        if (regexp("/servers/", entry) == 0):
                                                if (regexp("/nodes/", entry) == 1):
                                                        symname = AdminConfig.showAttribute(entry, "symbolicName" )
                                                        print "--> symbolic name is "+symname
                                                        if (symname == varname):
                                                                found = "true"
                                                                print "--> found the variable, and the entry id is "+entry+" *****"
                                                                print "--> break from for loop "
                                                                break 
                                                        #endIf 
                                                #endIf 
                                        #endIf 
                                        i += 1  #forNext
                                #endWhile  (#endFor)
                                if (found == "false"):
                                        entry = vid
                                        print "--> the variable is not found, return vid "+vid+" "
                                #endIf 
                                return entry
                        #endIf 
                #endIf 
        #endFor 
        print "--> nothing located and will return empty entry !!!!!"
        return ""
#endDef 


######
# delete_tklm_j2c_auth_alias {alias_id}
#
#   This procedure deletes the J2C authentication alias used by
#   TKLM DataSource.  This alias will have the name as 
#   <node_name>/tklm_db.
#

#puts "--> profiling proc delete_tklm_j2c_auth_alias"

def delete_tklm_j2c_auth_alias ( alias_id):
        global AdminConfig

        print "--> proc create_tklm_j2c_auth_alias"
        adid = find_tklm_j2c_auth_alias(alias_id )
        if (adid != ""):
                print "--> J2C authentication alias found, delete it"
                AdminConfig.remove(adid)
                return "SUCCESS"
        #endElse 
        return "UNCHANGED"
#endDef 

######
# find_tklm_j2c_auth_alias {alias_id}
#
#   This procedure tries to find the J2C authentication alias with
#   the userId "tklm" and part of alias name as "tklm_db".  If
#   the alias is found, the alias id will be returned.  Otherwise, 
#   an empty string will be returned.
#

#puts "--> profiling proc find_tklm_j2c_auth_alias"

def find_tklm_j2c_auth_alias ( alias_id ):
        global AdminConfig

        print "--> proc find_tklm_j2c_auth_alias"
        print "--> find j2c authentication alias "+alias_id
        securityId = AdminConfig.list("Security" )
        print "--> security id is - "+securityId
        adEntry = AdminConfig.showAttribute(securityId, "authDataEntries")
        adEntry = wsadminToList(adEntry)
        print "--> auth data entry is - "+str(adEntry)
        nEntries = len(adEntry)
        print "--> nEntries: "+str(nEntries)
        adid = ""
        i = 0  #forStart
        while ( i < nEntries ):  #forTest
                adi = adEntry[i]
                print "--> adi "+adi
                #?PROBLEM? (jacl 2058) previous LINDEX may need variable.split("xx")
                #     set userid [$AdminConfig showAttribute $adi userId] 
                #     puts "--> current userId is $userid"  
                #     if { $userid == "tklm" } 
                alias = AdminConfig.showAttribute(adi, "alias" )
                print "--> the current alias "+alias
                #     if {[regexp $alias_id $alias] == 1} 
                if (alias_id == alias):
                        print "--> found j2c alias "+alias_id+" with alias id "+adi
                        # set tklmAlias $alias
                        adid = adi
                        break 
                #endIf 
                i += 1  #forNext
        #endWhile  (#endFor)
        print "--> tklm j2c authentication alias id:  "+adid+" "
        return adid
#endDef 

#-----------------------------------------------------------------
# delete_jdbc_provider {scope dbtype is_xa is_was6}
#
# Delete the jdbc driver provider under the scope which can be at cluster or server level
#
#puts "--> profiling proc delete_jdbc_provider"

def delete_jdbc_provider ( scope, dbtype):
        global AdminConfig

        tklm_jdbc = find_jdbc_driver(scope, dbtype, "false", "true" )
        # If TKLM JDBC provider is found, delete it
        if (tklm_jdbc != ""):
                print "--- found TKLM JDBC Provider, delete it"
                AdminConfig.remove(tklm_jdbc)
                return "SUCCESS"
        #endElse 
        return "UNCHANGED"
#endDef 

######
# delete_tklm_datasource {jdbcid dsname}
#
# Delete TKLM datasource

#puts "--> profiling proc delete_tklm_datasource"

# proc delete_tklm_datasource {sid, dsname}
def delete_tklm_datasource (jdbcid, dsname):
        global AdminConfig

        print "--> proc delete_tklm_datasource"
        # Find datasource for the node:server
        dsid = find_object_id(sid, "DataSource", "jndiName", dsname )
        if (dsid != ""):
                print "Datasource exists and will be deleted"
                AdminConfig.remove(dsid)
                return "SUCCESS"
        #endIf 
        return "UNCHANGED"
#endDef 



#-----------------------------------------------------------------
# get_name - Return the base name of the config object. 
#-----------------------------------------------------------------
#puts "--> profiling proc get_name"
def get_name ( args ):
        # arg[0] - object id

        id = args.split(LINE_SEPARATOR)[0]
        endIndex = (id.find("(") - 1)

        return id[0:endIndex+1]
#endDef 


#-----------------------------------------------------------------
# find_jdbc_driver {scope dbtype is_xa is_was6}
# Find the JDBC driver resource under the scope

# The following puts is useful for debugging in case of syntax
# errors in specific procs
#puts "--> profiling proc find_jdbc_driver"

def find_jdbc_driver ( scope, dbtype, is_xa, is_was6 ):
        global AdminConfig

        print "--> proc find_jdbc_driver"

        jdbclist = AdminConfig.list("JDBCProvider", scope ).split(LINE_SEPARATOR)
        njdbc = len(jdbclist)
        found = "false"
        if (dbtype == "IBM_DB"):
                if (is_was6 == "false"):
                        classname = "COM.ibm.db2.jdbc.DB2XADataSource"
                        provider_name = "TKLM DB2 JDBC Provider"
                else:
                        if (is_xa == "true"):
                                provider_name = "TKLM XA DB2 JDBC Provider"
                                classname = "com.ibm.db2.jcc.DB2XADataSource"
                        else:
                                provider_name = "TKLM non-XA DB2 JDBC Provider"
                                classname = "com.ibm.db2.jcc.DB2ConnectionPoolDataSource"
                        #endElse 
                #endElse 
        #endIf 
        if (dbtype == "ORACLE_DB"):
                classname = "oracle.jdbc.xa.client.OracleXADataSource"
        #endIf 
        if (dbtype == "MS_DB"):
                classname = "com.jnetdirect.jsql.JSQLXADataSource"
        #endIf 

        scope_name = get_name(scope )
        print "--> the scope name of the scope is "+scope_name
        print "--> number of jdbc provider is "+str(njdbc)
        print "--> searching jdbc class "+classname

        # set tklm_jdbc [find_object_id 

        tklm_jdbc = ""
        i = 0  #forStart
        while ( i < njdbc ):  #forTest
                jdbcId = jdbclist[i]
                #?PROBLEM? (jacl 372) previous LINDEX may need variable.split("xx")
                print "--> current jdbcid is "+jdbcId
                if (regexp(provider_name, jdbcId) == 1):

                        endIndex = (jdbcId.find("|") - 1)
                        if (endIndex < 0):
                                endIndex = (jdbcId.find(":") - 1)
                        #endIf 
                        sString = jdbcId[0:endIndex+1]
                        stIndex = (sString.rfind("/") + 1)
                        sName = sString[stIndex:endIndex+1]

                        print "--> Extracted jdbc provider scope name is "+sName

                        if (scope_name == sName):
                                impclass = AdminConfig.showAttribute(jdbcId, "implementationClassName" )
                                print "--> extracted jdbc class name is "+impclass
                                if (impclass == classname):
                                        tklm_jdbc = jdbcId
                                        break 
                                #endIf 
                        #endIf 
                #endIf 
                i += 1  #forNext
        #endWhile  (#endFor)

        print "--> tklm_jdbc: "+tklm_jdbc
        return tklm_jdbc
#endDef 



######
# find_object_id {scopeId obType obKey obValue}
#
# This procedure finds the object id based on the input parameters.
# They are:
# scopeId : the scope that the object is under, such as server id (sid)
# obType  : the type of object, such as DataSource, WASQueueConnectionFactory
# obKey   : the key word to be used for comparison, such as jndiName, implementationClassName
#   obValue : the value of the key word to be compared
#
# If the object is found, the object id will be returned.
# If the object if not found, an empty string will be returned.
#

#puts "--> profiling proc find_object_id"
def find_object_id ( scopeId, obType, obKey, obValue ):
        global AdminConfig

        print "--> proc find_object_id"
        print "--> search scope id         : "+scopeId
        print "--> search object type id   : "+obType
        print "--> search object key word  : "+obKey
        print "--> search object key value : "+obValue

        oblist = AdminConfig.list(obType, scopeId )
        oblist = wsadminToList(oblist)
        noblist = len(oblist)
        print "--> number of object list: "+str(noblist)
        obid = ""
        i = 0  #forStart
        while ( i < noblist ):  #forTest
                obi = oblist[i]
                curObValue = AdminConfig.showAttribute(obi, obKey )
                print "--> current value of the object key is "+curObValue

                if (curObValue == obValue):
                        obid = obi
                        break 
                #endIf 
                i += 1  #forNext
        #endWhile  (#endFor)

        print "--> object id is :  "+obid+" "
        return obid
#endDef 



######
# delete_tklm_j2c_auth_alias {scope, alias_id}
#
#   This procedure deletes the J2C authentication alias used by
#   TKLM DataSource.  This alias will have the name as 
#   <node_name>/tklm_db.
#

#puts "--> profiling proc delete_tklm_j2c_auth_alias"

def delete_scheduler (scope, name):
        global AdminConfig

        print "--> proc delete_scheduler"
        schedulerId = find_object_id(scope, "SchedulerConfiguration", "name", name);
        if (schedulerId != ""):
                print "--> scheduler found, delete it"
                AdminConfig.remove(schedulerId)
                return "SUCCESS"
        #endElse 
        return "UNCHANGED"
#endDef 


###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
###########################################################################################################
#
# SCRIPT STARTS HERE
#
# Removes TKLM related objects from WAS config
#
###########################################################################################################
log = sys.argv[0]
node = "TIPNode" 
server = "server1"
dbType = "IBM_DB"
tklmdbAlias = "tklmdb"
print "node name is "+node
print "server name is "+server

cid = AdminConfig.list("Cell" )
sid = AdminConfig.getid("/Node:"+node+"/Server:"+server )
node = AdminControl.getNode( )

#Delete J2C AUTHENTICATION ALIASES tklm_db
rc = delete_tklm_j2c_auth_alias(tklmdbAlias)
print "Debug --> return from delete_tklm_j2c_auth_alias. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf 

#Delete Non-XA DataSource
rc = delete_tklm_datasource(sid, "jdbc/tklmDS")
print "Debug --> delete_tklm_datasource Non-XA JMS. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf 

#Delete XA DataSource
rc = delete_tklm_datasource(sid, "jdbc/tklmXADS")
print "Debug --> delete_tklm_datasource Non-XA JMS. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf 

#Delete DB2 JDBC Provider 
rc = delete_jdbc_provider(sid, "IBM_DB")
print "Debug --> return from delete_jdbc_provider. rc: "+rc
if (rc != ""):
        AdminConfig.save( )
#endIf 

#Delete TKLM_HOME at NODE level
rc = delete_env_var_node(node, "TKLM_HOME")
print "Debug --> return from delete_env_var_node. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf

#remove TKLM_DB_JDBC_DRIVER_PATH at NODE level
rc = delete_env_var_node(node, "TKLM_DB_JDBC_DRIVER_PATH")
print "Debug --> return from delete_env_var_node. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf

#remove TKLM Scheduler
rc = delete_scheduler(sid, "TKLM Scheduler")
print "Debug --> return from delete_scheduler. rc: "+rc
if (rc == "SUCCESS"):
        AdminConfig.save( )
#endIf


