##to invoke the script, you have to pass three arguements: <tipadmin/wasadmin username>, <sklmadmin user> and <sklmadmin password>
import string, sys

tipuser = ""
sklmadminid = ""
sklmadminpwd = ""

if len(sys.argv) < 3 or len(sys.argv) > 3:
  sys.stderr.write("Invalid number of arguments\n")
  sys.exit(101)
else:
  if len(sys.argv) == 3:
     tipuser = sys.argv[0]
     print "tipuser=" + tipuser
     sklmadminid = sys.argv[1]
     sklmadminpwd = sys.argv[2]  

result=""
try: 
  params = "[-uniqueName uid=" + sklmadminid + ",o=defaultWIMFileBasedRealm]"
  result = AdminTask.deleteUser(params)
except:
  print result
  print sklmadminid + " user not found, we are going to create one"
try:
  params = "[-uid " + sklmadminid + " -password " + sklmadminpwd + " -sn key_lifecycle_manager_default_admin -cn key_lifecycle_manager_default_admin]"
  result = AdminTask.createUser(params)
  print result
except:
  print result
  print "Cannot create " + sklmadminid + " user"
  sys.exit()  

#####create securityofficer group#####
try:
  params = "[-cn klmSecurityOfficerGroup -memberUniqueName uid=" + sklmadminid + ",o=defaultWIMFileBasedRealm]"
  result =  AdminTask.createGroup(params) 
  print result
except:
  print "Cannot create klmSecurityOfficeGroup, exit"
  print result

#####create gucliaccess group#####
try:
  params = "[-cn klmGUICLIAccessGroup -memberUniqueName uid=" + sklmadminid + ",o=defaultWIMFileBasedRealm]"
  result =  AdminTask.createGroup(params) 
  print result
except:
  print "Cannot create klmGUICLIAccessGroup, exit"
  print result


#####create backuprestore group#####
try:
  result = AdminTask.createGroup('[-cn klmBackupRestoreGroup]')
  print result
except:
  print "Cannot create klmBackupRestoreGroup, exit"
  print result
  
#####create LTOAdmin group #####
try:
  result = AdminTask.createGroup('[-cn LTOAdmin]')
  print result
except:
  print "Cannot create LTOAdmin group, exit"
  print result
  
#####create LTOOperator group #####
try:
  result = AdminTask.createGroup('[-cn LTOOperator]')
  print result
except:
  print "Cannot create LTOOperator group, exit"
  print result
  
#####create LTOAuditor group #####
try:
  result = AdminTask.createGroup('[-cn LTOAuditor]')
  print result
except:
  print "Cannot create LTOAuditor group, exit"
  print result

####assign sklmadminid to klmSecurityOfficer role####
try:
  print ("Try to map " + sklmadminid + " to klmSecurityOfficer role")
  params = "[-roleName klmSecurityOfficer -userids " + sklmadminid + "]"
  result = AdminTask.mapUsersToAdminRole(params)
  print ("Mapped " + sklmadminid + " to klmSecurityOfficer role")
  print result
except:
  print "Failed to map " + sklmadminid + " to security officer role"
  print result

#####assign klmSecurityOfficerGroup to klmSecurityOfficer role#####
try:
  print ("Try to map security officer group to klmSecurityOfficer role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmSecurityOfficer -groupids klmSecurityOfficerGroup]')
  print ("Mapped securityOfficer group to klmSecurityOfficer")
  print result
except:
  print "Failed to map securityOfficer group to klmSecurityOfficer role"
  print result

#####assign klmSecurityOfficerGroup to suppressmonitor role#####
try:
  print ("Try to map security officer group to suppressmonitor role");
  result = AdminTask.mapGroupsToAdminRole('[-roleName suppressmonitor -groupids klmSecurityOfficerGroup]')
  print ("Mapped securityOfficer group to suppressmonitor role")
  print result
except:
  print "Failed to map securityOfficer group to suppressmonitor role"
  print result
  
  
 #####assign klmGUICLIAccessGroup to suppressmonitor role#####
try:
  print ("Try to map klmGUICLIAccessGroup group to suppressmonitor role");
  result = AdminTask.mapGroupsToAdminRole('[-roleName suppressmonitor -groupids klmGUICLIAccessGroup]')
  print ("Mapped klmGUICLIAccessGroup group to suppressmonitor role")
  print result
except:
  print "Failed to map klmGUICLIAccessGroup group to suppressmonitor role"
  print result
 
  #####assign klmGUICLIAccessGroup to monitor role#####
try:
  print ("Try to map klmGUICLIAccessGroup group to monitor role");
  result = AdminTask.mapGroupsToAdminRole('[-roleName Monitor -groupids klmGUICLIAccessGroup]')
  print ("Mapped klmGUICLIAccessGroup group to Monitor role")
  print result
except:
  print "Failed to map klmGUICLIAccessGroup group to monitor role"
  print result
    

#####assign klmBackupRestoreGroup to klmBackup and klmRestore role#####
try:
  print ("Try to map klmBackupRestore group to klmBackup and klmRestore role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmBackup -groupids klmBackupRestoreGroup]')
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmRestore -groupids klmBackupRestoreGroup]')
  print ("Mapped klmBackupRestore group to klmBackup and klmRestore roles")
  print result
except:
  print "Failed to map klmBackupRestoreGroup group to klmBackup and klmRestore role"
  print result

#####assign klmBackupRestoreGroup to suppressmonitor role#####
try:
  print ("Try to map klmBackupRestore group to suppressmonitor role");
  result = AdminTask.mapGroupsToAdminRole('[-roleName suppressmonitor -groupids klmBackupRestoreGroup]')
  print ("Mapped klmBackupRestore group to suppressmonitor role")
  print result
except:
  print "Failed to map klmBackupRestoreGroup group to suppressmonitor role"
  print result
  
#####assign LTOAdmin to these roles: LTO, klmCreate, klmView, klmDelete, klmModify, klmGet, klmAudit, klmConfigure, klmBackup, suppressmonitor#####
try:
  print ("Try to map LTOAdmin group to LTO role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName LTO -groupids LTOAdmin]')
  print ("Mapped LTOAdmin group to LTO role")
  print result
except:
  print "Failed to map LTOAdmin group to LTO role"
  print result
try:  
  print ("Try to map LTOAdmin group to klmCreate role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmCreate -groupids LTOAdmin]')
  print ("Mapped LTOAdmin group to klmCreate role")
  print result
except:
  print "Failed to map LTOAdmin group to klmCreate role"
  print result
try:  
  print ("Try to map LTOAdmin group to klmView role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmView -groupids LTOAdmin]')
  print ("Mapped LTOAdmin group to klmView role")
  print result  
except:
  print "Failed to map LTOAdmin group to klmView role"
  print result
try:  
  print ("Try to map LTOAdmin group to klmDelete role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmDelete -groupids LTOAdmin]')
  print ("Mapped LTOAdmin group to klmDelete role")
  print result  
except:
  print "Failed to map LTOAdmin group to klmDelete role"
  print result
try:  
  print ("Try to map LTOAdmin group to klmModify role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmModify -groupids LTOAdmin]')
  print ("Mapped LTOAdmin group to klmModify role")
  print result 
except:
  print "Failed to map LTOAdmin group to klmModify role"
  print result
try:   
  print ("Try to map LTOAdmin group to klmGet role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmGet -groupids LTOAdmin]')
  print ("Mapped LTOAdmin group to klmGet role")
  print result 
except:
  print "Failed to map LTOAdmin group to klmGet role"
  print result
try:  
  print ("Try to map LTOAdmin group to klmAudit role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmAudit -groupids LTOAdmin]')
  print ("Mapped LTOAdmin group to klmAudit role")
  print result  
except:
  print "Failed to map LTOAdmin group to klmAudit role"
  print result
try:     
  print ("Try to map LTOAdmin group to klmConfigure role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmConfigure -groupids LTOAdmin]')
  print ("Mapped LTOAdmin group to klmConfigure role")
  print result 
except:
  print "Failed to map LTOAdmin group to klmConfigure role"
  print result
try:    
  print ("Try to map LTOAdmin group to klmBackup role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmBackup -groupids LTOAdmin]')
  print ("Mapped LTOAdmin group to klmBackup role")
  print result
except:
  print "Failed to map LTOAdmin group to klmBackup role"
  print result
try:  
  print ("Try to map LTOAdmin group to suppressmonitor role");
  result = AdminTask.mapGroupsToAdminRole('[-roleName suppressmonitor -groupids LTOAdmin]')
  print ("Mapped LTOAdmin group to suppressmonitor role")
  print result
except:
  print "Failed to map LTOAdmin group to suppressmontior role"
  print result
  
#####assign LTOOperator to these roles: LTO, klmCreate, klmView, klmModify, klmBackup, suppressmonitor#####
try:
  print ("Try to map LTOOperator group to LTO role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName LTO -groupids LTOOperator]')
  print ("Mapped LTOOperator group to LTO role")
  print result
except:
  print "Failed to map LTOOperator group to LTO role"
  print result
try:  
  print ("Try to map LTOOperator group to klmCreate role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmCreate -groupids LTOOperator]')
  print ("Mapped LTOOperator group to klmCreate role")
  print result
except:
  print "Failed to map LTOOperator group to klmCreate role"
  print result
try:  
  print ("Try to map LTOOperator group to klmView role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmView -groupids LTOOperator]')
  print ("Mapped LTOOperator group to klmView role")
  print result   
except:
  print "Failed to map LTOOperator group to klmView role"
  print result
try:  
  print ("Try to map LTOOperator group to klmModify role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmModify -groupids LTOOperator]')
  print ("Mapped LTOOperator group to klmModify role")
  print result   
except:
  print "Failed to map LTOOperator group to klmModify role"
  print result
try:       
  print ("Try to map LTOOperator group to klmBackup role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmBackup -groupids LTOOperator]')
  print ("Mapped LTOOperator group to klmBackup role")
  print result
except:
  print "Failed to map LTOOperator group to klmBackup role"
  print result
try:  
  print ("Try to map LTOOperator group to suppressmonitor role");
  result = AdminTask.mapGroupsToAdminRole('[-roleName suppressmonitor -groupids LTOOperator]')
  print ("Mapped LTOOperator group to suppressmonitor role")
  print result
except:
  print "Failed to map LTOOperator group to suppressmonitor role"
  print result
  
  
#####assign LTOAuditor to these roles: LTO, klmView, klmAudit, suppressmonitor#####
try:
  print ("Try to map LTOAuditor group to LTO role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName LTO -groupids LTOAuditor]')
  print ("Mapped LTOAuditor group to LTO role")
  print result
except:
  print "Failed to map LTOAuditor group to LTO role"
  print result
try:  
  print ("Try to map LTOAuditor group to klmView role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmView -groupids LTOAuditor]')
  print ("Mapped LTOAuditor group to klmView role")
  print result 
except:
  print "Failed to map LTOAuditor group to klmView role"
  print result
try:   
  print ("Try to map LTOAuditor group to klmAudit role")
  result = AdminTask.mapGroupsToAdminRole('[-roleName klmAudit -groupids LTOAuditor]')
  print ("Mapped LTOAuditor group to klmAudit role")
  print result  
except:
  print "Failed to map LTOAuditor group to klmAudit role"
  print result
try:        
  print ("Try to map LTOAuditor group to suppressmonitor role");
  result = AdminTask.mapGroupsToAdminRole('[-roleName suppressmonitor -groupids LTOAuditor]')
  print ("Mapped LTOAuditor group to suppressmonitor role")
  print result
except:
  print "Failed to map LTOAuditor group to suppressmonitor role"
  print result  

result = AdminConfig.save()
print result 
try:
  result = AdminTask.listGroupIDsOfAuthorizationGroup()
  print result
  result = AdminTask.listUserIDsOfAuthorizationGroup()
  print result
except:
  print result 
  
